//////////////////////////////////////////////////////////////////////////////
//
// (C) Copyright Vicente J. Botet Escriba 2008. Distributed under the Boost
// Software License, Version 1.0. (See accompanying file
// LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//
// See http://www.boost.org/libs/sync for documentation.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __BOOST_SYNC_THREAD_SHARED_MUTEX__HPP
#define __BOOST_SYNC_THREAD_SHARED_MUTEX__HPP

#include <boost/thread/shared_mutex.hpp>
#include <boost/sync/lockable_traits.hpp>

namespace boost { namespace sync {
    
typedef boost::shared_mutex thread_shared_mutex;

template<>
struct timed_interface_tag<boost::shared_mutex> {
	typedef has_timed_interface_tag type; 
};
template<>
struct reentrancy_tag<boost::shared_mutex> {
	typedef non_recursive_tag type; 
};
template<>
struct category_tag<boost::shared_mutex> {
	typedef upgradable_lock_tag type; 
};
template<>
struct scope_tag<boost::shared_mutex> {
	typedef multi_threaded_tag type; 
};

template <>
struct best_condition<boost::shared_mutex> {
	typedef boost::condition_variable_any type;
};

}
}

#endif
